<?php

/**
 * Implementation of hook_drush_command().
 */
function cacheaudit_drush_command() {
  $items['cacheaudit'] = array(
    'description' => '',
  );
  return $items;
}

function drush_cacheaudit() {
  $results = array();
  $results = module_invoke_all('cacheaudit');
  foreach ($results as $cat => $result) {
    drush_print($cat);
    drush_print(str_pad('', 100, "-"));
    drush_print_table($result, TRUE);
  }
}

function system_cacheaudit() {
  $vars = array(
    'block_cache',
    'cache',
    'cache_lifetime',
    'page_cache_maximum_age',
  );

  $results = array();
  foreach ($vars as $var) {
    $results[] = array($var, variable_get($var, '<not set>'));
  }
  return array('system' => $results);
}

function views_cacheaudit() {
  $defaults = array(
    'name' => '',
    'display' => '',
    'status' => 'Enabled',
    'type' => '',
    'results_lifespan' => '',
    'output_lifespan' => '',
    'block_caching' => '',
  );
  $results = array();
  $results[] = array('View', 'Display', 'Status', 'Plugin', 'Results', 'Output', 'Block cache');

  foreach (views_get_all_views() as $name => $view) {
    // Get the default display first.
    $default = isset($view->display['default']->display_options['cache']) ? $view->display['default']->display_options['cache'] : array();
    $status = !isset($view->disabled) || !$view->disabled ? 'Enabled' : 'Disabled';
    $results[] = array('name' => $name, 'display' => 'default', 'status' => $status) + $default;

    foreach ($view->display as $display_name => $display) {
      // Skip default display since we already got it above.
      if ($display_name === 'default') continue;

      $display_results = array();
      if (isset($display->display_options['cache'])) {
        $display_results = $display->display_options['cache'];
      }

      if ($display->display_plugin === 'block') {
        if (empty($display_results)) {
          $display_results = $default;
        }
        if (isset($display->display_options['block_caching'])) {
          $display_results['block_caching'] = cacheaudit_get_cache_constant($display->display_options['block_caching']);
        }
      }

      if ($display_results) {
        $results[] = array_merge($defaults, array('name' => $name, 'display' => $display_name, 'status' => $status), $display_results);
      }
    }
  }
  return array('views' => $results);
}

function cacheaudit_get_cache_constant($constant_value) {
  switch ($constant_value) {
  case DRUPAL_CACHE_CUSTOM:
    $constant_name = 'DRUPAL_CACHE_CUSTOM';
    break;
  case DRUPAL_NO_CACHE:
    $constant_name = 'DRUPAL_NO_CACHE';
    break;
  case DRUPAL_CACHE_CUSTOM:
    $constant_name = 'DRUPAL_CACHE_CUSTOM';
    break;
  case DRUPAL_CACHE_GLOBAL:
    $constant_name = 'DRUPAL_CACHE_GLOBAL';
    break;
  case DRUPAL_CACHE_PER_PAGE:
    $constant_name = 'DRUPAL_CACHE_PER_PAGE';
    break;
  case DRUPAL_CACHE_PER_ROLE:
    $constant_name = 'DRUPAL_CACHE_PER_ROLE';
    break;
  case DRUPAL_CACHE_PER_USER:
    $constant_name = 'DRUPAL_CACHE_PER_USER';
    break;
  }
  return $constant_name;
}
